#!/bin/bash


file=$1

DMESG1=/tmp/dmesg.log
DMESG2=/tmp/dmesg.log.1
DMESGTMP=/tmp/dmesg.tmp

function gather_dmesg {
	
	touch $DMESG1
	touch $DMESG2
	size=`ls -l $DMESG1 | awk  '{print $5}'`
	
#rotate it if it gets too big
	if [ $size -gt 50000 ];
	then
		cp -f $DMESG1 $DMESG2
		echo "######  Rotating dmesg.log on " `date` > $DMESG1
	fi
	
	if [ $file == /tmp/fulltrace-info.txt ]
	then
		echo -e "\n### dmesg fulltrace on " `date` >> $DMESG1
	fi
	
	dmesg -c |grep -v ^NWFPE > $DMESGTMP
	size=`ls -l $DMESGTMP | awk  '{print $5}'`
	
	if [ $size -gt 0 ];
	then
		echo "###### new dmesg info on " `date` >> $DMESG1
		cat $DMESGTMP >> $DMESG1
	fi
}

log_info()
{
	echo -e "\n#######" "$1:" >> $file
	eval $1 >> $file
}

gather_dmesg

log_info "echo q | top"
log_info "date"
log_info "uptime"
log_info "free"
log_info "ps aux"
log_info "df"
# log_info "dmesg"
log_info "cat /proc/li*"
log_info "cat /proc/meminfo"
log_info "cat /proc/cmdline"
log_info "cat /proc/FPGA_VERSION"
log_info "cat /proc/interrupts"
log_info "cat /proc/l1_stats"
log_info "cat /proc/l2_stats"
log_info "lsmod"
log_info "ifconfig"
log_info "ifconfig -a"
log_info "iptables -L"
log_info "iptables -L -t nat"
log_info "netstat -na"

