#!/bin/bash

PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/usr/fallback

if [ -z "${1}" ] || [ -z "${2}" ]; then
	echo "Usage: ${0} <wait> <sink ipaddr>"
	exit 1
fi

if [ "${1}" = "0" ]; then
	let "wait_time=60"
else
	let "wait_time=60 * ${1}"
fi

sink_addr=${2}

max_port=0
port_list=$(query_isgw i | grep "* Port")

for i in $(seq 1 8); do
	res=$(expr match "${port_list}" ".* Port \(${i}\)")
	if [ -z "${res}" ]; then
		break;
	fi

	let "max_port=${max_port}+1"
done

if [ -z "${max_port}" ]; then
	exit 1;
fi

while [ 1 ]; do

	i=1
	while [ ${i} -le ${max_port} ]; do
		query_isgw l2up${i} > /dev/null
		let "i=${i}+1"
	done

	# wait a second
	sleep 1

	i=1
	while [ ${i} -le ${max_port} ]; do
		res_str=$(query_isgw i | grep "* Port ${i}")
		l2s_str=$(expr match "${res_str}" ".*L2Link \([a-zA-Z]*\)")

		if [ "${l2s_str}" != "UP" ]; then
			 snmptrap -v 2c -c public ${sink_addr} '' .1.3.6.1.4.1.29886.2.1 .1.3.6.1.4.1.29886.2.1 s "Port ${i}: ${l2s_str}"
		fi

		let "i=${i}+1"
	done

	sleep ${wait_time}
done
